\ ==============================================================
\ [TITLE]     8051 ANS Forth ENVIRonment words set. 
\ [FILE]      ENVIR.FRT
\ [CATEGORY]  Standard tool
\ [VSN]       1.00 
\ [CREATED]   March 21, 1995, Willem Ouwerkerk 
\ [LASTCHNGD] March 23, 1995, Willem Ouwerkerk 
\ [COPYRIGHT] Dutch Forth Users Group (C) 1995
\ [COMPILE]   CursusForth Environments
\ [MODULE OF] 8051-ANS-Forth 
\ [USES]      ...
\ [AUTHOR]    Willem Ouwerkerk 
\ [PURPOSE]   Implementation of the ANS Forth word ENVIRONMENT?
\             This implementation takes 673 bytes.
\ ==============================================================

?DEF -ENVIR [IF]  -ENVIR  [THEN]  MARKER -ENVIR

\ ---- EVIRONMENT Vocabulary ----------------------------------

HERE

EXTRA ALSO  DEFINITIONS
WORDLIST  CONSTANT ENVIR-WORDLIST  
ENVIR-WORDLIST SET-CURRENT

$FF CONSTANT /COUNTED-STRING    ( -- n )
$80 CONSTANT /HOLD              ( -- n )
$80 CONSTANT /PAD               ( -- n )
$08 CONSTANT ADDRESS-UNIT-BITS  ( -- n )
TRUE CONSTANT CORE              ( -- flag )
FALSE CONSTANT CORE-EXT         ( -- flag )
FALSE CONSTANT FLOORED          ( -- flag )
255 CONSTANT MAX-CHAR           ( -- u )
: MAX-D  $7FFF.FFFF ;           ( -- d )
$7FFF CONSTANT MAX-N            ( -- n )
$FFFF CONSTANT MAX-U            ( -- u )
: MAX-UD $FFFF.FFFF ;           ( -- ud )
$40 CONSTANT RETURN-STACK-CELLS ( -- n )
$40 CONSTANT STACK-CELLS        ( -- n )

FALSE CONSTANT DOUBLE           ( -- flag )
TRUE CONSTANT EXCEPTION         ( -- flag )
TRUE CONSTANT EXCEPTION-EXT     ( -- flag )
FALSE CONSTANT FACILITY         ( -- flag )
FALSE CONSTANT FACILITY-EXT     ( -- flag )
$10 CONSTANT #LOCALS            ( -- n )
TRUE CONSTANT LOCALS            ( -- flag )
TRUE CONSTANT LOCALS-EXT        ( -- flag )
TRUE CONSTANT TOOLS             ( -- flag )
FALSE CONSTANT TOOLS-EXT        ( -- flag )
$0E CONSTANT WORDLISTS          ( -- n )
TRUE CONSTANT SEARCH-ORDER      ( -- flag )
TRUE CONSTANT SEARCH-ORDER-EXT  ( -- flag )
FALSE CONSTANT STRING           ( -- flag )

#8052 CONSTANT CPU              ( -- u )

EXTRA DEFINITIONS

: >ENVIRONMENT      ( c-addr u -- )     \ Utility to compile new words
    GET-CURRENT >R                      \ in the ENVIR word list.
    GET-CONTEXT >R                      \ This version allows the
    ENVIR-WORDLIST SET-CURRENT          \ changing of variables to.
    ENVIR-WORDLIST SET-CONTEXT
    ['] EVALUATE  CATCH
    R> SET-CONTEXT
    R> SET-CURRENT  THROW
    ;

FORTH DEFINITIONS

\G c-addr is the address of a character string and u is the strings
\G count. The character string should contain a keyword from the
\G environment queries to be checked for. If the keyword is unknown,
\G the returned flag is false; otherwise, the flag is true and the 
\G i*x returned is of the type specified.
: ENVIRONMENT?      ( c-addr u -- false | i*x true ) \ Envir
    ENVIR-WORDLIST  SEARCH-WORDLIST
    IF  EXECUTE TRUE EXIT  THEN  FALSE
    ;

\G ccc should contain a keyword from the environment queries to be 
\G checked for. If the keyword is unknown, the returned flag is false;
\G otherwise the flag is true and the i*x returned is of the type 
\G specified.
: ENVIR?            ( "ccc" -- false | i*x true )   \ Envir
    BL PARSE ENVIRONMENT?
    ;

-2 SET-ORDER

HERE SWAP - .( Lengte van de code: ) . .( bytes )

                       \ (* End of Source *) /
