\ ==============================================================
\ [TITLE]     8051 ANS Forth analog to digital converter words. 
\ [FILE]      ADC.FRT
\ [CATEGORY]  Example
\ [VSN]       1.00 
\ [CREATED]   January 13, 1994, Willem Ouwerkerk 
\ [LASTCHNGD] October 18, 1994, Willem Ouwerkerk 
\ [COPYRIGHT] Dutch Forth Users Group (C) 1994
\ [COMPILE]   CursusForth Environments
\ [MODULE OF] ANS Forth 
\ [USES]      ...
\ [AUTHOR]    Willem Ouwerkerk 
\ [PURPOSE]   Use of the SFR building word and using the ADC.
\ ==============================================================

\ Make SFR ADCON high level accessable. See also: SFR
$D8 SFR ADCON   ( -- byte )             \ Adc  controle register

\ Make SFR ADDAT high level accessable. See also: SFR
$D9 SFR ADDAT   ( -- byte )             \ Adc  data register

\ Make SFR DAPR high level accessable. See also: SFR
$DA SFR DAPR    ( -- byte )             \ Adc  conversie start en ref.

\G Do an analog to digital conversion from input n. The result
\G will be the value byte, which is in the range from 0 to 255.
: AD    ( n -- byte )
    DUP 7 U> ABORT" Invalid ADC address" \ Adc  Secure input ports
    ADCON  $F8 AND  OR  TO ADCON        \ Select ADC input
    0 TO DAPR                           \ Start converter
    BEGIN
        ADCON $10 AND 0=                \ Conversion ready ?
    UNTIL
    ADDAT                               \ Read converted value
    ;

                    \ (* End of Source *) /
