\ ==============================================================
\ [TITLE]     8051 ANS Forth BENCHmark. 
\ [FILE]      BENCH.FRT
\ [CATEGORY]  Example
\ [VSN]       1.00 
\ [CREATED]   December 31, 1993, Willem Ouwerkerk 
\ [LASTCHNGD] June 16, 1995, Willem Ouwerkerk 
\ [COPYRIGHT] Dutch Forth Users Group (C) 1994
\ [MODULE OF] 8051-ANS-Forth 
\ [AUTHOR]    4te Dimension
\ [PURPOSE]   8051 speed test from 'Die Vierte Dimension'
\ ==============================================================

\ Benchmark for de 8051 from a German BBS
\ after an article from the "4te Dimension". 
\
\ The fastest 8051 Forth they have will reach a score of: 10.5 sec.
\ in 150 ns EPROM and a max. clock frequency of 12 MHz. But do not
\ take to much notice of this because it is a hand compiled demo.
\ Do not change anything in the code for comparision purposes,
\ use below used format for the same reason. Below the results
\ for this system with built in stack security.
\ 
\ *************************************************************
\
\ Benchmark:          Vierte Dimension 3/93
\ Speicherverbrauch:  125 Bytes including headers !!
\ Modifikationen:     0
\ CPU:                80C32 / 80C535 / DS80C320 / N87C251 (8Bit)
\ Syst-Takt:          12 MHz
\ RAM:                100nsec
\ ROM:                150nsec
\ Forth:              Willem Ouwerkerk & Frans Cornelis
\
\ Small cpu board with 80C32 at 12 MHz and 32K ROM and 32K RAM.
\ Zeit:               18 sec   ( = 180 sec / 10 x BENCH with runtime security )
\ Zeit:               14.8 sec ( = 148 sec / 10 x BENCH without security )
\ Zeit:               14.2 sec ( = 142 sec / 10 x BENCH for vsn 1.11- )
\ Zeit:               13.7 sec ( = 137 sec / 10 x BENCH for vsn 1.11- )
\                     And TO and FROM used on variable BVAR !!!
\
\ Same board and Forth, but with Dallas DS80C320 processor
\ Zeit:               7 sec    ( = 70 sec  / 10 x BENCH idem with DS80C320 )
\ Zeit:               3.5 sec  ( = 35 sec  / 10 x BENCH idem with DS80C320 24 MHz )
\ Zeit:               3.1 sec  ( = 31 sec  / 10 x BENCH idem with 2 cycle MOVX )
\ Zeit:               2.9 sec  ( = 29 sec  / 10 x BENCH idem with 2 cycle MOVX )
\                     And TO and FROM used on variable BVAR !!!
\
\ Same board and Forth, but with new Intel N87C251 processor
\ Zeit:               9.8 sec  ( = 98 sec  / 10 x BENCH with security and N87C251 at 12 MHz )
\ Zeit:               8.1 sec  ( = 81 sec  / 10 x BENCH idem without security )
\ Kommentar:          A real functioning ANSI-Forth system !!
\
\ MfG   Olaf Haeggquist
\
\ *************************************************************
MARKER -BENCH
HERE  DECIMAL
 
#5 CONSTANT FIVE        ( By benchmark used CONSTANT )
   VARIABLE BVAR        ( By benchmark used VARIABLE )

\G This benchmark leaves a result that must be devided by ten to
\G accomplish the actual result. 
: BENCH  ( -- )                         \ Bench
        #2560  0                        \ #2560 is ten times Bench
        DO      1 
                BEGIN   DUP SWAP 
                        DUP ROT 
                        DROP 
                        1 AND
                        IF      FIVE + 
                        ELSE    1- 
                        THEN    BVAR !
                        BVAR @  DUP $100 AND 
                 UNTIL
                 DROP 
        LOOP 
        ;
 
CR .( Size: ) HERE SWAP - . .( bytes. ) CR

\ CR .( Hit any key to start ) KEY DROP
\ CR
\ CR .( Running benchmark )  7 EMIT  BENCH  7 EMIT

                    \ (* End of Source *) /
