\ ==============================================================
\ [TITLE]     8052-ANS-Forth RELAIS woorden. 
\ [FILE]      RELAIS.FRT
\ [CATEGORY]  Tools
\ [VSN]       1.10 
\ [CREATED]   December 3, 1995, Willem Ouwerkerk 
\ [LASTCHNGD] August 16, 1998, Willem Ouwerkerk 
\ [COPYRIGHT] Dutch Forth Users Group (C) 1995-1998
\ [MODULE OF] 8052-ANS-Forth 
\ [AUTHOR]    Willem Ouwerkerk 
\ [PURPOSE]   Relais control with ULN2803
\ ==============================================================

?DEF -RELAIS  [IF]  -RELAIS  [THEN]  MARKER -RELAIS

ASSEMBLER

\G Access eight relais through output port 1.
P1: SFR OUTPUT  ( -- byte )             \ Relais  Make P1 high level available
FORTH

\ Demo for relais control, random selection of lamps

: SECONDS           ( u -- )            \ Delays u seconds
    0 ?DO  1000 MS  LOOP
    ;

#31421 VALUE RND                        \ Random work location

: RANDOM            ( -- u )            \ Make random number u
    RND 31421 * 6927 +  DUP TO RND
    ;

: CHOOSE            ( u1 -- u2 )        \ Make random number u2 the
    RANDOM UM* NIP                      \ range of u2 is 0 to u1-1
    ;

: LAMPS             ( -- )              \ Change lamps every now and then
    0 TO OUTPUT                         \ All lamps off
    #31421 TO RND                       \ Initialise random work location
    BEGIN
        256 CHOOSE                      \ Get selection value
        DUP CR .  TO OUTPUT             \ Select lamps
        90 CHOOSE  20 MAX  SECONDS      \ Wait 20 to 90 seconds
    STOP? UNTIL                         \ Until a key is hit !
    ;

' LAMPS     AUTOSTART                   \ Start this application

\ End
